# Справка по продукту Vanessa.ADD

## Каталог docs

Предназначен для хранения файлов документации в формате Markdown

Содержит:

* рекомендаций разработчикам и команде проекта
* описание релизов (RELEASE NOTES) и оперативного плана (ROADMAP)

Для быстрого входа рекомендуем [почитать статьи или посмотреть видео](xdd/Статьи-и-видео-по-тестированию-в-1С.MD)

- [Описание возможностей готовых универсальных дымовых тестов](../tests/smoke/readme.md)
- [Документация по разделу xdd/tdd](/doc/xdd/README.MD)
- [BDD-Документация по фреймворку Vanessa.Add](doc/bdd/README.md)

Vanessa.ADD работает только с платформой 1С версии 8.3.5 и выше в режиме совместимости с 8.3.5 и выше.

Для использования на платформе 1С 8.2 и 8.3 до 8.3.6 используйте продукты-родители
- [xUnitFor1C](https://github.com/xDrivenDevelopment/xUnitFor1C) 4.0.0.0 и 3.0.0.8
- [Vanessa-Behavior](https://github.com/silverbulleters/vanessa-behavior) версию 1.1.131
- помните, что Vanessa.ADD ушла далеко вперед от этих продуктов по многим показателям


## Разделы справки

* [Обширная документация по BDD-части](./bdd/README.md)
    * [Подготовка автодокументации - видео-документация и т.п.](https://github.com/silverbulleters/add/blob/develop/doc/bdd/%D0%BF%D0%BE%D0%B4%D0%B3%D0%BE%D1%82%D0%BE%D0%B2%D0%BA%D0%B0-%D0%B0%D0%B2%D1%82%D0%BE%D0%B4%D0%BE%D0%BA%D1%83%D0%BC%D0%B5%D0%BD%D1%82%D0%B0%D1%86%D0%B8%D0%B8.md)

* Разделы по tdd-тесты кодом

    * [Принципы написания тестов/фич/сценариев](xdd/Принципы-написания-тестов.MD)

    * [Методы проверки/утверждений для использования кода шагов/тестов](xdd/Методы-проверки---утверждения.MD)
        * [Текучие (fluent) утверждения](xdd/Текучие-(fluent)-утверждения.MD) - очень красивые и довольно удобные. Можно выполнять несколько проверок в одной строке проверки.
        * [Базовые утверждения](xdd/Базовые-утверждения.MD) - простые, устаревшие, но все еще замечательные утверждения.
        * [Проверка таблиц и табличных документов](xdd/Проверка-таблиц-и-табличных-документов.MD)

    * [Система плагинов](xdd/Система-плагинов.MD)
        * [Генерация данных](xdd/Генерация-данных.MD)
        * [ВременныеФайлы](xdd/ВременныеФайлы.MD)
        * [КомандныйФайл](xdd/КомандныйФайл.MD)
        * [ПарсерКоманднойСтроки](xdd/ПарсерКоманднойСтроки.MD)
        * [ЗапросыИзБД](xdd/ЗапросыИзБД.MD)
        * [ЗагрузчикПользовательскихНастроек](xdd/Загрузчик-пользовательских-настроек.MD)
        * [ГенераторОтчетаJUnitXML](xdd/ГенераторыОтчетов.MD#генераторотчетаjunitxml)
        * Генераторы отчетов тестирования:
                * [ГенераторОтчетаAllureXMLВерсия2](xdd/ГенераторыОтчетов.MD#генераторотчетаallurexmlверсия2)
                    * [(устаревший) ГенераторОтчетаAllureXML](xdd/ГенераторыОтчетов.MD#устаревший-генераторотчетаallurexml)
                * [ГенераторОтчетаJUnitXML](xdd/ГенераторыОтчетов.MD#генераторотчетаjunitxml)
                * [ГенераторОтчетаMXL](xdd/ГенераторыОтчетов.MD#генераторотчетаmxl)

    * [Дымовые тесты (тесты открытия всех форм)](../tests/smoke/readme.md)
