# v5.8.0 Многострочный текст Gherkin + Новые дымовые + Еще больше ускорения + Исправлены ошибки

## BDD

- Поддержка многострочного текста Gherkin #426

- Значительно упрощен текст шагов, формируемых из кнопконажималки
  - все для удобства пользователей и повышения читаемости фич
  - например, значения для таблиц в кнопконажималке формируются без лишних апострофов и т.п.

- Очередное значительное улучшение производительности #411 для следующих блоков
  - многократное ускорение чтения фич
  - работа с макетами
  - работа со скриншотами
  - Обработка записи журнала действий пользователя и генерации текста временной фичи

## Дымовые тесты

- Новые дымовые тесты проверки общих модулей и подсистем  #387
- Новые дымовые тесты по бизнес-процессам #409 #412
- Исправлены различные ошибки

## BDD (прочее)

- Добавлена опция показа подробных отладочных сообщений в логе выполнения Ванессы #424
- Улучшен сбор информации о процессах 1С #425
  - Метод Ванесса.ПолучитьМассивPIDОкон1С и аналогичный метод плагина "УправлениеПриложениями" научился собирать процессы 1С по заголовку, что полезно для отслеживания процессов, связанных с одной базой
- Заменено наименование "Vanessa Behavior" на "Vanessa.ADD" #383 #384
- Исправлено для отчетов Allure
  - В отчете Allure пройденные тесты стали отображаться серым цветом (как skipped) #418
  - В отчет Allure не добавлялись скриншоты с ошибками при падении сценария #423
- Исправлено падение шага `Тогда таблица "" содержит строки:` в случае наличия похожих заголовков в таблице #417
- Исправлено - Некорректно обрабатывается шаг по нажатию кнопки выбора в таблице у поля составного типа #427
- Исправлено - Затираются параметры подключения TestClient #419 #421

## TDD

- Исправлено - в синхронном режиме сломались отчеты в пакетном режиме в 5.7.0 #414 #416
- Исправлен сломавшийся алгоритм определения поддержки асинхронных вызовов  #413
- Устранено периодическое падение некоторых тестов #54
- Код тестовой конфигурации приведен в соответствии со стандартом именования общих модулей

## Плагины

- УФ+ОФ: Утверждение `Содержит` из плагина 'УтвержденияBDD' научилось проверять многострочные строки
  - например, сразу выдается, какая именно подстрока не найдена, вместо указания факта несовпадения сравниваемых строк


# v5.7.0 Ускорение, новые и доработанные дымовые, новые плагины (в т.ч. по созданию данных), потоковый вывод в отчеты Allure и JUnit

В код релиза внесены доработки от **20** человек !!

    - Контрибьюторы проекта выполнили огромное количество доработок.

- Дополнительно коллега Владимир Литвиненко выпустил большой цикл статей по Vanessa.ADD на Инфостарт-е - 1-я статья https://infostart.ru/public/969637 и т.д.

    - Владимир, еще раз огромнейшее спасибо от всех пользователей и соучастников!

- Для BDD- и TDD-части, а также для дымовых тестов реализован потоковый вывод в файлы отчетов (junit и Allure) по мере выполнения фич или тестов #389 #393 #399
    - важно для борьбы с зависаниями тестов/фич и анализа возникающих проблем

- Значительно дополнена и актуализирована документация проекта по дымовым тестам, BDD- и TDD-частям - #11 #366 #372 #380 #330 #334 и т.д.
    - расширен FAQ, добавлено много новых ответов
- Поддержана совместимость с 8.3.5 (полностью) и 8.2 (частично) #357 #336 #173 #359

## Новые плагины - и для BDD, и для TDD

- Новый плагин "Заглушки" для генерации данных на лету #381
- Плагин "Движения документа" для проверки проведения и сравнения движений документа #325 #302
- Плагин "ИнтернетПочта" #394 #397 #398
- Плагин "ИтераторМетаданных" - используется для анализа метаданных, например, в дымовых тестах по метаданным (см. ниже)
- Плагин "ЗагрузчикПользовательскихНастроек" для BDD - Загрузка глобальных переменных сохраняемого контекста и настроек из внешнего файла #343 #346

## Дымовые тесты

- Дымовые тесты открытия форм научились работать через тест-клиент - решена проблема зависания на модальных окнах #403
    - доработаны в рамках Enterprise-поддержки
- Новые дымовые тесты
    - по метаданным plugins #360 #371 #365 #361 https://infostart.ru/public/947305
    - по проверке макетов СКД #374 #375
- Добавлена возможность настройки через json-файлы для дымовых тестов ввода на основании #407
    - доработаны в рамках Enterprise-поддержки

Дополнения/исправления:
- Доработаны дымовые тесты для иерархических справочников #402
- Не работает исключение при указании полного пути исключаемой формы в json-файле настройки #376 #392
- Исправлены ошибки дымовых тестов ввода на основании #340 #396

## Генерация данных

- Новый плагин "Заглушки" #381
- Добавлена кнопка "Загрузить макет в базу" для обычного приложения #326

Исправления/дополнения:
- Определение типа маршрута бизнес процесса. #354
- Добавлена выгрузка/загрузка стандартного реквизита "ТипЗначения" для ПВХ #338
- Нельзя загрузить Справочник "Банковские счета" из-за неверной работы с владельцем #200

## BDD

- Сохранение отчета Allure сразу после выполнения сценария, а после выполнения фичи #399
- Загрузка глобальных переменных сохраняемого контекста и настроек из внешнего файла #343 #346
- Заголовки форм сравниваются точнее, в т.ч. и по шаблонам со звездочкой #370 #367
- Доработка подключения тест-клиента #351 #352 - например, для передачи контекста сохраняемых переменных
- Полезные функции добавления произвольных данных в отчет Allure для использования в реализации собственных шагов #334 #330
- Новый шаг ожидания завершения фонового задания и закрытия формы длительной операции (БСП) #333
- Новый шаг для работы с почтой "Когда я отвечаю на это сообщение" #404
- Возможность указания путей запуска SikuliX разными способами #345 #355

Исправления/дополнения:
- Периодический баг при использовании нескольких библиотек #327
- Исправлено - Шаг "И Я закрыл все окна клиентского приложения кроме "Нужное окно"" не всегда закрывает все окна #406
- Исправлено ошибка - шаг "Когда я удаляю все элементы Справочника", в котором нет иерархии, выдает ошибку: "Поле не найдено ЭтоГруппа" #230 #390
- Заполнение поля КаталогПроекта по-умолчанию #363 #369
- Исправлено очень медленное выполнение шага "в поле с именем 'ИмяПоля ввожу значение глобальной переменной "ИмяПеременной" #349 #350
- Исправлены проблемы в библиотечном шаге "я делаю паузу 2 секунды" #337
- Исправлено периодическое падение шага `Ожидаем завершения фонового формирования отчета в течение "10" секунд` #329
- Исправлено: Не сохраняются (некорректно читаются из сохраненных настроек) пути к библиотекам шагов #401

## TDD

- Формирование результатов тестов на ходу, по мере выполнения тестов #389
- Потоковый вывод результатов тестов #393
- Исправления для работе в английской локализации #385

Дополнения/исправления:
- Ошибка при инициализации настроек на сервере #386
- ОФ: Ошибка при открытии обозревателя TDD #358
- Исправлено - УФ: из формы xddTestRunner нельзя открыть внешний инструмент при включенном режиме асинхронности #328

## Прочее

- Исправлены проблемы кода, выявленные с помощью "Sonar 1C (BSL) Plugin" #331
- очень много задач доработаны в рамках Enterprise-поддержки клиентов


# v5.6.0 Ускорение + иерархия тестов для Allure + документация

## Значительное ускорение работы продукта

 - Ускорение работы продукта при чтении фич и файлов шагов, выполнении сценариев, генерации шагов #320

- Решены многие из накопленных технических долгов

    - в т.ч. и проблемы от SonarBSL #255

    - Серьезно упрощена работа с настройками BDD в плагине "LoadSettings" #319

 - Плагин "Регулярные выражения" #48 #311 #317
 - Плагин "ГенераторОтчетовAllureXMLВерсия2" #294

## Генератор данных

 - СериализаторMXL - Доработана до рабочего состояния загрузка данных регистра бухгалтерии. #313

 - Исправлено: Нельзя сохранить макет в файл в асинхронном режиме #250

## TDD и Дымовые тесты

 - Удобная 3-уровневая группировка тестов, в т.ч. и дымовых тестов, в отчете Allure с помощью нового плагина "ГенераторОтчетовAllureXMLВерсия2" #294

 - Исправлена ошибка использования json-файлов настройки дымовых тестов #321

## BDD

 - Открытие фичи в редакторе VSCode на конкретной строке фичи из окна фич по команде контекстного меню #290

 - Исправлен парсинг фича файла с учетом текста описания сценария #56 #323

 - Правильный выбор в окне выбора типов и других специальных модальных окнах 1С #289 #273

 - Добавлен дополнительный поиск в ПолучитьЗначениеИзКонтекстаЕслиЭтоВозможно() #316

 - Добавление библиотечого шага "Я открываю основную форму объекта ЗначениеОбъекта" #297

 - Показ важных сообщений в логе командной строки #301
 - При запуске проверяется правильность настройки библиотек #193

## Документация

Серьезно расширена документация. Смотрите каталог [docs](./docs/readme.md)

    - В FAQ добавлено описание Ванесса.ПроверитьХХХ() и хдд.ПроверитьХХХ() в удобочитаемом виде #140
    - добавлены описания многих плагинов

    - Портирование документации по xUnit  #306
    - Перенести документацию из Wiki xUnitFor1C в формате markdown в папку #76
    - и т.п.

## Прочее

 - Исправлено: При `opm run cepf` не удаляются старые epf-бинарники, если для них нет соответствующего каталога с исходниками #113
 - Исправлено: Неверно собирается файл шагов при выполнении opm run cepf #291

    - Исправлены прочие ошибки, в т.ч. #308


# v5.5.5 Доработки дымовых + TDD-браузера

## Дымовые тесты

+ Исправлена ошибка удаления существующих объектов при запуске дымовых https://github.com/silverbulleters/add/issues/293
+ Дымовые тесты выдают ошибку, если в json-файле отсутствует ключ "ПропускаемыеИсключения" https://github.com/silverbulleters/add/issues/296

## TDD

+ Исправлено: Не работает простая перегрузка для перегрузки текущего теста, а требуется перезагрузка всего браузера тестов https://github.com/silverbulleters/add/issues/288
+ Доработана загрузка тестов из истории для случае асинхронного режима https://github.com/silverbulleters/add/issues/303
+ Удален встроенный в конфигурацию xUnitFor1C https://github.com/silverbulleters/add/issues/304

## BDD

+ Исправлена проблема неверных файлов шагов после установки релиза silverbulleters/add#291

[Подробное описание изменений релиза v5.5.5](https://github.com/silverbulleters/add/milestone/8?closed=1)

Изменения/коммиты после последнего релиза 5.5.5:
https://github.com/silverbulleters/add/compare/5.5.0...5.5.5

# v5.5.0 Асинхронность TDD (и дымовых) + Дымовые тесты + Генератор данных + новые возможности и шаги в BDD

## Поддержка асинхронности в tdd-части продукта

* Дымовые тесты научились работать с любыми конфигурациями 1С, в т.ч. и с теми, в которых запрещены синхронное вызовы #5
* tdd-часть продукта научилась работать с любыми конфигурациями 1С, в т.ч. и с теми, в которых запрещены синхронное вызовы #5
* Поддержка асинхронного режима работы 1С #269

## Дымовые тесты

* УФ: Доработаны дымовые тесты #277
    * переделан тест для существующих элементов справочника
        * сначала пытаемся найти существующий элемент и открыть его форму
        * если не удалось найти, только тогда создаем новые пустые элементы
    * автоматически пропускаются типовые обработки, при открытии которых получаем ошибку `Обработка не предназначена для непосредственного использования`
    * научились правильно отрабатывать кейс, когда при открытии формы может происходить подмена формы и открытие другой формы
    * исключена ошибка падения тестов, когда удаление элементов может быть запрещено или нет прав на удаление
* Пропуск форм, при открытии которых выдан определенный текст исключения #283
    * добавлен отдельный ключ `ПропускаемыеИсключения` в json-файле настройки
* Для дымовых тестов открытия форм конфигурации добавлена проверка на наличии полного имени формы в списке исключений #236
    * спасибо @AnatoliyBritko

## Генератор данных

* Научились загружать наборы записей регистров #258 #267 #272 #282
    * регистров накопления
    * регистров бухгалтерии
    * регистров расчета

    * спасибо @asheichenko

* Ошибка в проверке типов параметров УтвержденияПроверкаТаблиц.ПроверитьРавенствоТаблиц #275
    * спасибо @yehorh
* Добавлена сериализация и десериализация данных с помощью json. #260
    * спасибо @pumbaEO

## Новые плагины

* Плагин для управления приложениями `УправлениеПриложениями` - запуск, завершение #162 #261

## Проверка поведения (BDD)

* Добавлена возможность создавать сложные структуры сценариев со вложенными сценариями и параметрами #263
    * спасибо @PavelVir

* Новые шаги запуска команд на базе плагина `УправлениеПриложениями ` #261
    * `Я выполняю команду "НужноеПриложение" с параметрами "несколько параметров"`
    * `Я сообщаю вывод команды "НужноеПриложение"`
    * `я вижу в консоли вывод "вывод приложения"`
    * `Код возврата равен 0`
    * `установлен OneScript`

* Новые и доработанные шаги загрузки из макета #224 #279 :
    * Новый шаг `я загружаю макет "Макет" с переменными`
    ```gherkin
    И я загружаю макет "Макет" с переменными:
	| ИмяПеременнойИзМакета |
    ```
    или другой вариант
    ```gherkin
    И я загружаю макет "Макет" с переменными:
	| ИмяПеременнойИзМакета | НовоеИмяПеременнойВКонтексте |
    ```
    * Все шаги загрузки из макетов научились загружать файлы макетов из каталога проекта, а не только из макета внешней обработки
    * Основной шаг загрузки из макета `я загружаю макет "Макет"`
    * Шаг `я создаю fixtures по макету "Макет"` считается устаревшим

* УФ: Добавление автопоказа отчета allure - по отдельной команде или через флаг в настройках #233  #245

* Набор шагов и методов для работы с Fake-SMTP-Server для тестирования отправки почты #278 #280
    * [Документация](https://github.com/silverbulleters/add/blob/master/features/libraries/%D0%9F%D0%BB%D0%B0%D0%B3%D0%B8%D0%BD%D1%8B/step_definitions/README.md)
    * спасибо @KrapivinAndrey

* Новые и доработанные шаги работы с БД #251
    ```gherkin
    Когда в базе нет элементов справочника "Справочник1" с указанными в таблице наименованиями
        | Элемент1 |
        | Элемент2 |
	И  Я создаю элементы справочника "Справочник1" с указанными в таблице наименованиями
        | Элемент1 |
        | Элемент2 |
    И в базе есть элементы справочника "Справочник1" с указанными в таблице наименованиями
        | Элемент1 |
        | Элемент2 |
    ```

* Новые шаги для работы с БД #258 #267 #272 #282

    ```gherkin
	Когда в метаданных есть РегистрСведений "РСПодчиненРегистраторуПериодический"
	И я удаляю все записи РегистрСведенийПодчиненРегистратору "РСПодчиненРегистраторуПериодический"
	И в базе нет записей РегистрСведений "РСПодчиненРегистраторуПериодический"
	Тогда В базе появилась хотя бы одна запись РегистрСведений "РСПодчиненРегистраторуПериодический"
    ```

    ```gherkin
 	Когда в метаданных есть РегистрНакопления "РегистрНакопленияОбороты"
	И я удаляю все записи РегистрНакопления "РегистрНакопленияОбороты"
	И в базе нет записей РегистрНакопления "РегистрНакопленияОбороты"
	Тогда В базе появилась хотя бы одна запись РегистрНакопления "РегистрНакопленияОбороты"
    ```

    ```gherkin
    Когда в метаданных есть РегистрБухгалтерии "РегистрБухгалтерии1"
	И я удаляю все записи РегистрБухгалтерии "РегистрБухгалтерии1"
	И в базе нет записей РегистрБухгалтерии "РегистрБухгалтерии1"
	Тогда В базе появилась хотя бы одна запись РегистрБухгалтерии "РегистрБухгалтерии1"
    ```

    ```gherkin
	Когда в метаданных есть РегистрРасчета "РегистрРасчета1"
	И я удаляю все записи РегистрРасчета "РегистрРасчета1"
	И в базе нет записей РегистрРасчета "РегистрРасчета1"
	Тогда В базе появилась хотя бы одна запись РегистрРасчета "РегистрРасчета1"
    ```

* Исправлены небольшие проблемы при генерации файла шагов
* Флаг "Создавать области при генерации кода" включен по умолчанию при генерации файла шагов #234
* Файлы VBParamsXXX.json теперь полностью соответствуют стандарту JSON #256
* Доработана совместимость с 8.2 #261
* Доработана документация #244 #97 #129
    * В FAQ добавлены полезные вопросы и ответы #129

### Создание авто- и видео-инструкций

* Обновлена основная документация MakeAutoVideo.md #270
* Исправление ошибок при записи видео #257 #259 #265, в т.ч.:
    * Каталог tools/VideoTools включен в поставку пакета #268
    * При загрузке настроек видео по умолчанию нужно устанавливать каталог для временных файлов видео не в каталоге ADD
* спасибо @ZhdanovR

## TDD прочее

* TDD - Научились читать json-файлы настройки с комментариями #276
* TDD - Возможность получения пути к файлу обработки текущего теста или шага
    * как при выполнении тестов,
    * так и при их загрузке (в `ЗаполнитьНаборТестов` или `ПолучитьСписокТестов`) #74 #246
* Исправлена ошибка открытия xddTestRunner на 8.2 #159


# v5.4.0 Управление дымовыми тестами + Улучшение загрузки тестов/фич + Доработаны шаги

Список изменений:

## Дымовые тесты

- Новый инструмент для управления дымовыми тестами #158 #237

## Выполнение фич и тестов

- TDD: Теперь можно загружать тесты, у которых имя файла и внутреннее имя обработки не совпадают #208 #182
- BDD: Теперь можно загружать шаги из файлов фич, у которых имя файла шага и внутреннее имя обработки не совпадают #216
- BDD: При генерации файла обработки приводим имя файл в нормализованное имя, совпадающее с внутренним именем обработки #239

## Шаги для фич (BDD)
- Доработка поиска активного окна, доработка указания при выборе из списка #229
- Использовение переменных контекста через "$ИмяПеременнойКонтекста$" в сценарии - например, `И я буду выбирать внешний файл "C:\repo\$ИмяФайла$"` #240 #238
- Доработка для отчета cucumber.json - прикрепления файла скриншота к отчету #231

## Генератор данных

- Исправлена ошибка загрузки макетов в режиме совместимости 8.2 #212 #242

[Подробное описание изменений релиза v5.4.0](https://github.com/silverbulleters/add/milestone/5?closed=1)

Изменения/коммиты после последнего релиза 5.3.1:
https://github.com/silverbulleters/add/compare/5.4.0...5.3.1

# v5.3.1 Внешние инструменты + исправления - Генератор макетов + Английская локализация  + Дымовые тесты + браузер фич

Список изменений:

## Генератор данных
+ Ошибка генерации данных, если у пользователя недостаточно прав на создание элементов справочника #205
+ Исправлена ошибка загрузки "Реквизит недоступен для элемента" #197
+ Ошибка генератора "Ошибка установки значения свойства 'ТипЗначения': Тип не является подмножеством типа значений плана видов характеристик;" #203
+ Задвоение элементов при загрузке предопределенных элементов #181

## Английская локализация
+ В английской локализации не загружаются дымовые тесты  #207

## Внешние инструменты
+ ОФ+УФ: Возможность открытия внешних инструментов в bddRunner аналогично xddTestRunner #209
+ Добавлены исходники внешних инструментов из tools/epf/utils #227
+ Добавлен каталог tools в поставку add #198 #228

## Дымовые тесты
+ Исправлено не очень частая проблема: зависание дымовых тестов из-за постоянного роста массива представлений основных форм #217
+ Исправлено: ошибочно исключались некоторые объекты (обработки/отчеты) при запуске дымовых тестов #226

## Прочее
+ BDD: В ОФ в форме настроек добавлен каталог проекта #202
+ Добавлено создание файла релиза add-x.x.x.zip при сборке пакета продукта #210
+ Исправлено: При пакетном запуске не загружаются и не выполняются фичи, открывается только bddRunner #222
+ Исправлено: Очищается папка проекта, если не указать --xddExitCodePath #213

[Подробное описание изменений релиза v5.3.1](https://github.com/silverbulleters/add/milestone/3?closed=1)

Изменения/коммиты после последнего релиза 5.1.1.0:
https://github.com/silverbulleters/add/compare/5.1.1.0...5.3.1

# v5.1.1.0 Генератор данных + работа в обычном приложении

Список изменений:

Генератор данных:
+ Исправлено: Ошибка: реквизит недоступен для группы #188
+ Исправлено: Задвоение документов при указании ссылки в макете #183

ОФ:
+ Исправлено: В ОФ формируется неверное время в отчете allure, а в УФ правильное время #195
+ Исправлено: ОФ: не формируется отчет Аллюр при запуске в bddRunner, а в VB 1.1.131 формируется при тех же настройках #194


[Подробное описание изменений релиза v5.1.1.0](https://github.com/silverbulleters/add/milestone/4?closed=1)

Изменения/коммиты после последнего релиза 5.1.0.0:
https://github.com/silverbulleters/add/compare/5.1.0.0...5.1.1.0

# v5.1.0.0 - Отладка + Дымовые + Генерация данных + Настройка

<a id="markdown-отладка" name="отладка"></a>
## Отладка

+ Введена возможность абсолютно штатной отладки кода шагов BDD, тестов TDD и любых плагинов #133
  + штатная отладка в 1С теперь возможна
    + для файловых баз
    + для клиент-серверных баз, расположенных на одной машине

<a id="markdown-проверка-поведения---bdd" name="проверка-поведения---bdd"></a>
## Проверка поведения - BDD

+ Портированы изменения из vanessa-behavior 1.1.131 #139 #175
    + Возвращены ранее пропущенные фичи/шаги #112
        + Работа с макетами - каталог `features/libraries/Макеты`
        + Работа с выводом текста - каталог `features/libraries/ВыводТекста`
        + Открытие форм - каталог `features/libraries/Формы`
        + Работа с автоинструкцией - каталог `features/libraries/Автоинструкции`

+ работа с макетами стала проще. #136
    + При поиске макета в методе "ПолучитьМакетОбработки", если не нашли макет в файле обработки, тогда ищем макет в каталоге проекта и вложенном каталоге "Файлы"
        + Если не удалось найти макет в обработке или каталоге, пишем информацию в ЖР
    + Исправлена ошибка - неверно работает шаг `Дано Табличный документ формы с именем "" стал равен макету с именем ""`

+ Ускорение работы инструмента

+ Появилась возможность указать путь к конкретным фичам через командную строку запуска vanessa-runner, в т.ч. и русские имена файлов и каталогов? #106

+ ОФ: Исправлено - При открытии обычной формы bddRunner.epf дерево тестов не строится #143

+ Использование абсолютно штатного формата json-файлов в отличие от собственного формата json, ранее введеном в vanessa-behavior
    + Исправление чтения настроек из json-файла на платформенное, если возможно.  #119
    + Добавлена json-схема для валидации VBParams.json #70
    + В json-файле в качестве ключей могут быть не только идентификаторы  #117 #118

+ Исправлены критические ошибки из Сонара для bddRunner #57

+ исправлены многочисленные мелкие ошибки из наследия vanessa-behavior
    + Примеры исправлений:
        + Режим асинхронности проверяем только по версии приложения  #142
        + Сокращение длинных имен файлов фич #153
        + При первом запуске bdd в базе получаем ошибку #154
        + При загрузке фич возникает ошибка (ADD 5.0.0.124) #179
        + Для фич, запускаемых в режиме самотестирвоания, убрано лишнее переоткрытие формы bddRunner #87
        + и т.п.

<a id="markdown-дымовые-тесты" name="дымовые-тесты"></a>
## Дымовые тесты

+ Добавлена возможность строгого порядка выполнения любых тестов, в т.ч. и дымовых тестов, а не только сценарных тестов  #109 #41
    + есть возможность настроить этот параметр в json-файле настроек дымовых тестов
+ УФ: Добавлена группировка по виду метаданного, виду объекта и по количеству #133
    + в json-файле настроек дымовых тестов
    + аналогично ОФ из xUnitFor1C
+ УФ: Добавлена возможность исключения по виду метаданных #133
    + в json-файле настроек дымовых тестов
    + аналогично ОФ из xUnitFor1C
+ Вывод сообщений в ЖР регулируется теперь настройкой в конфигурационном файле

<a id="markdown-генерация-данных" name="генерация-данных"></a>
## Генерация данных

+ Исправление неверной загрузки уже существующих данных в Генераторе данных #168 #172
+ Обход ошибки платформы по созданию ключа записи регистра сведений на клиенте #116

<a id="markdown-проверка-кодом---tdd-xunit" name="проверка-кодом---tdd-xunit"></a>
## Проверка кодом - TDD, xUnit

+ Добавлена возможность строгого порядка выполнения любых тестов, в т.ч. и дымовых тестов, а не только сценарных тестов  #109 #41
+ Исправлены критические ошибки из Сонара для bddRunner и xddTestRunner #57
+ УФ: Исправлена проблема загрузки файлов тестов xUnit, когда есть расхождение между именем файла и именем обработки #146
+ Добавлена json-схема для валидации xUnitParams.json #71

+ Вывод лога тестирования xUnit в лог-файл при пакетном запуске, в т.ч. и через vanessa-runner #81
    + Вывод сообщений о прохождении тестов в лог-файл для возможности передачи в консоль, не дожидаясь завершения сеанса 1С #75

+ Портированы последние изменения из xUnitFor1C #80
    + В файле теста можно использовать глобальную экспортную переменную `ПутьКФайлуПолный`
    + в нее будет установлен полный клиентский путь к файлу теста, что позволяет обращаться к соседним файлам на клиенте

+ Новые ключи в json-файле настроек
    + "Отладка" - булево
    + "ДобавлятьИмяПользователяВПредставлениеТеста" - булево
    + "ДелатьЛогВыполненияСценариевВТекстовыйФайл" - булево
    + "ИмяФайлаЛогВыполненияСценариев" - пример "$workspaceRoot/build/log-xunit.txt"

<a id="markdown-тесты-для-пользователей-в-режиме-обычных-форм-и-управляемых-форм" name="тесты-для-пользователей-в-режиме-обычных-форм-и-управляемых-форм"></a>
### Тесты для пользователей в режиме обычных форм и управляемых форм

+ Тесты для пользователей  #165 #148

<a id="markdown-плагины" name="плагины"></a>
## Плагины

+ Новый плагин "Файлы" для работы с файлами, каталогами и их путями #134
+ Новый плагин по проверке таблиц `УтвержденияПроверкаТаблиц` #49 #73

<a id="markdown-документация" name="документация"></a>
## Документация

    + Добавлен FAQ: как использовать add после установки через opm install add #83
    + Добавлен FAQ про переход на add из xUnitFor1C и vanessa-behavior #77
    + Использование Ansible для настройки сборочных нод #94 #161
    + Методика работы с объемными исходниками #137

<a id="markdown-прочее" name="прочее"></a>
## Прочее

+ Исправлены ошибки параллельной сборки на Jenklins-сервере #135
+ Исправление запуска сборки через команды opm #90

[Подробное описание изменений релиза v5.1.0.0](https://github.com/silverbulleters/add/milestone/2?closed=1)

Изменения/коммиты после последнего релиза 5.0.0.124:
https://github.com/silverbulleters/add/compare/5.0.0.124...5.1.0.0

<a id="markdown-vanessa-add-50xxx" name="vanessa-add-50xxx"></a>
### Vanessa-ADD 5.0.XXX

* Начало истории Vanessa-ADD - https://github.com/silverbulleters/add

<a id="markdown-vanessa-behavior-11131" name="vanessa-behavior-11131"></a>
### Vanessa-Behavior 1.1.131
* Исправлена ошибка в шаге: And table "List" contains lines
* Исправлен досадный баг в режиме запрета синхронных вызовов.

<a id="markdown-11130" name="11130"></a>
### 1.1.130
* При показе сравнения макетов, если в эталоне в ячейке был указан символ *, то и в текущем значении макета будет подставлен символ *
* Доработал шаг "Я перехожу к строке содержащей подстроки". Учел особенности 8.3.12.
* Расширил работу шага. Теперь поддерживается 'Я выбираю из списка "$ИмяПеременной$"'

<a id="markdown-11129" name="11129"></a>
### 1.1.129
* Обновил перевод. Добавил информации при выводе сообщений о дублях перевода.
* Добавил шаги для ввода выражения в поле таблицы.

<a id="markdown-11128" name="11128"></a>
### 1.1.128
* Добавил шаг: Затем Я копирую текущий профиль TestClient с установкой параметров
* Исправил сравнения строк когда используется символ *
* Добавил возможность при сравнении таблиц использовать переменные контекста вида $МояПеременная$
* Добавил параметр в JSON - ПриоритетНастроекПользователя.

<a id="markdown-11127" name="11127"></a>
### 1.1.127
* Добавил параметр - позволяющий указать свой таймаут для асинхронных шагов. ТаймаутДляАсинхронныхШагов.
* Исправил ошибку загрузки Структуры сценария на английском языке
* Исправил https://github.com/silverbulleters/vanessa-behavior/issues/695
* Доработал механизм сравнения таблиц.
* Добавил шаг: И в таблице "ТабличнаяЧасть1" я устанавливаю флаг с именем "ТабличнаяЧасть1РеквизитБулево"
* Добавил шаг: И в таблице "ТабличнаяЧасть1" я снимаю флаг с именем "ТабличнаяЧасть1РеквизитБулево"

<a id="markdown-11126" name="11126"></a>
### 1.1.126
* Добавил генерацию шага, ожидающего закрытия окна, после нажатия кнопки "Провести и закрыть"

<a id="markdown-11125" name="11125"></a>
### 1.1.125
* Добавил шаг, чтобы можно было переходить к строке таблицы, когда значения заданы с использованием символа *
```Gherkin
И     в таблице "Список" я перехожу к строке по шаблону
  | Код       | Наименование       |
  | "00000000*" | '*Элемент*2'             |
```
* Теперь при смене активного окна автоматически снимается фиксирование формы для поиска элемента.
* Исправил ошибку, когда web клиент не переподключался.
* Исправил поиск макета в приложенной обработке и в каталоге проекта. Сделал универсально.
* Добавил сброс кеша снипетов шагов при переходе с предыдущих версий.
* Исправил ошибку экранирования апострофа при генерации шага.
* Исправил ошибку в переводе en.
* Исправил перевод шага, когда параметры содержали спецсимволы.

<a id="markdown-11124" name="11124"></a>
### 1.1.124
* Убрал из epf явное использование СтрШаблон.
* Добавил шаги условий:
```Gherkin
Если таблица "ИмяТаблицы" равна макету "ИмяМакета" тогда
Если таблица "ИмяТаблицы" равна переданной тогда
		| 'Имя колонки' |
		| 'Значение'    |
```

* Добавил прикрепление таблиц и макетов к строке шага
* Начал изменять правила поиска элементов на форме. Для поиска элемента формы по имени надо указать !.
* Добавил шаги ввода даты начала месяца
* Добавил cmd и json файлы быстрой проверки на платформе 8.3.11 и 8.3.12.
* Добавил поддержку Вьетнамского языка
* Исправил ошибку, при получении таблицы в которой есть вертикальная черта.

<a id="markdown-11123" name="11123"></a>
### 1.1.123
* Исправление ошибки работы с флагами.

<a id="markdown-11122" name="11122"></a>
### 1.1.122
* Обновил help.
*Как узнать детали ошибки.*
*Работа со сценариями на других языках.*
* Добавил шаги для фиксирования формы, в которой надо искать элементы
```Gherkin
И я фиксирую форму "ИмяФормы"
И я отменяю фиксирование формы
```

<a id="markdown-11121" name="11121"></a>
### 1.1.121
* Рефактроинг описания шагов
* Добавил возможность показать диалог сравнения таблиц эталона и текущего значения, если этот шаг сравнивал значения таблиц или макетов.
Это делается в форме, которая показывает детали ошибки.

<a id="markdown-11120" name="11120"></a>
### 1.1.120
* Решение #691
* Переделал работу с шагами выбора из списка.
Теперь генерируются шаги вида
```Gherkin
И из выпадающего списка "ИмяПоля" я выбираю точное значение "ЗначениеПоля"
И из выпадающего списка "ИмяПоля" я выбираю по строке "ЧастьСтроки"
```

<a id="markdown-11119" name="11119"></a>
### 1.1.119
* Добавил шаг для создания каталога
* Добавил шаг для очищения каталога

<a id="markdown-11118" name="11118"></a>
### 1.1.118
* Подготовка к локализации сообщений. Рефакторинг кода.

<a id="markdown-11117" name="11117"></a>
### 1.1.117
* Сделал поиск в известных шага также и по описанию.
